// ==============================================================
//	This file is part of Glest (www.glest.org)
//
//	Copyright (C) 2001-2005 Martio Figueroa
//
//	You can redistribute this code and/or modify it under 
//	the terms of the GNU General Public License as published 
//	by the Free Software Foundation; either version 2 of the 
//	License, or (at your option) any later version
// ==============================================================

#ifndef _GLEST_GAME_STATS_H_
#define _GLEST_GAME_STATS_H_

namespace Glest{ namespace Game{

struct PlayerStats{
	PlayerStats();

	int teamIndex;
	bool victory;
	int kills;
	int deaths;
	int unitsProduced;
	int resourcesHarvested;
};

// =====================================================
// 	class Stats
//
///	Player statistics that are shown after the game ends
// =====================================================

class Stats{
private:
	PlayerStats *playerStats;
	int factionCount;
	int thisFactionIndex;
public:
	void init(int factionCount, int thisFactionIndex);
	~Stats();

	int getThisFactionIndex() const	{return thisFactionIndex;}
	int getFactionCount() const		{return factionCount;}

	bool getVictory(int factionIndex) const				{return playerStats[factionIndex].victory;}
	int getTeam(int factionIndex) const					{return playerStats[factionIndex].teamIndex;}
	int getKills(int factionIndex) const				{return playerStats[factionIndex].kills;}
	int getDeaths(int factionIndex) const				{return playerStats[factionIndex].deaths;}
	int getUnitsProduced(int factionIndex) const		{return playerStats[factionIndex].unitsProduced;}
	int getResourcesHarvested(int factionIndex) const	{return playerStats[factionIndex].resourcesHarvested;}

	void setTeamIndex(int playerIndex, int teamIndex)	{playerStats[playerIndex].teamIndex= teamIndex;}
	void setVictorious(int playerIndex);
	void kill(int killerFactionIndex, int killedFactionIndex);
	void produce(int producerFactionIndex);
	void harvest(int harvesterFactionIndex, int amount);
};

}}//end namespace

#endif
